Logo AND Algorithmique Numérique Distribuée

Public GIT Repository
be compatible with the standard of cmake+MPI
[simgrid.git] / src / smpi / smpirun.in
1 #!/usr/bin/env sh
2
3 # Copyright (c) 2007-2019. The SimGrid Team. All rights reserved.
4
5 # This program is free software; you can redistribute it and/or modify it
6 # under the terms of the license (GNU LGPL) which comes with this package.
7
8 @CMAKE_SMPI_COMMAND@
9
10 SIMGRID_VERSION="@SIMGRID_VERSION_STRING@"
11 SIMGRID_GITHASH="@SIMGRID_GITHASH@"
12
13 DEFAULT_LOOPBACK_BANDWIDTH="498000000Bps"
14 DEFAULT_LOOPBACK_LATENCY="0.000004s"
15 DEFAULT_NETWORK_BANDWIDTH="$((26 * 1024 * 1024))Bps"
16 DEFAULT_NETWORK_LATENCY="0.000005s"
17 DEFAULT_NUMPROCS="4"
18 DEFAULT_SPEED="100flops"
19
20 LOOPBACK_BANDWIDTH="${DEFAULT_LOOPBACK_BANDWIDTH}"
21 LOOPBACK_LATENCY="${DEFAULT_LOOPBACK_LATENCY}"
22 NETWORK_BANDWIDTH="${DEFAULT_NETWORK_BANDWIDTH}"
23 NETWORK_LATENCY="${DEFAULT_NETWORK_LATENCY}"
24 SPEED="${DEFAULT_SPEED}"
25
26 PRIVATIZE="--cfg=smpi/privatization:${SMPI_PRIVATIZATION:-@HAVE_PRIVATIZATION@}"
27
28 SIMOPTS="--cfg=surf/precision:1e-9 --cfg=network/model:SMPI"
29
30 #usage to print the way this script should be called
31 usage () {
32     cat <<EOF
33 Usage: $0 [OPTIONS] -platform <xmldesc> -hostfile <hostfile> program [program-options]
34        $0 [OPTIONS] -platform <xmldesc> -hostfile <hostfile> -replay <tracefile> [program] [program-options]
35 Options:
36   -keep-temps                # don't remove the generated files after execution
37   -wrapper <command>         # use command to run the program (e.g. "valgrind" or "gdb --args")
38   -gdb                       # run within GDB (-wrapper "gdb --args" -keep-temps)
39   -lldb                      # run within LLDB (-wrapper "lldb --" -keep-temps)
40   -vgdb                      # run within Valgrind+GDB (-wrapper "valgrind --vgdb=yes --vgdb-error=0" -keep-temps)
41   -map                       # display the machine on which each process rank is mapped
42   -np <numprocs>             # use that amount of processes from the hostfile.
43                              # By default, all processes of the hostfile are used.
44   -no-privatize              # Disable the globals privatization, that is activated by default
45   -trace-ti                  # activate time independant tracing (for replay, default in smpi_simgrid.txt)
46   -trace                     # activate tracing (Paje, default in smpi_simgrid.trace)
47   -trace-comment <comment>   # put a comment on the top of the trace file
48   -trace-comment-file <file> # put file contents on the top of the trace file as comment
49   -trace-grouped             # group MPI processes by location
50   -trace-resource            # trace resource utilization
51   -trace-file <tracefile>    # name of the tracefile (simgrid_smpi.trace)
52   -replay <tracefile>        # replays a trace instead of actually executing an application
53
54   -version                   # Displays the SimGrid version (human readable)
55   -git-version               # Displays the git hash of SimGrid
56
57 or (deprecated usage):
58   $0 [-keep-temps] [-np <numprocs>] [-bandwidth <bytes/sec>] [-latency <secs>] program [program-options]
59
60 EOF
61 }
62
63 #check if we have at least one parameter
64 if [ $# -eq 0 ]
65 then
66     usage
67     exit
68 fi
69
70 WRAPPER=""
71 HOSTFILE=""
72 HOSTFILETMP=0
73 MAPOPT=0
74 REPLAY=0
75
76 unset pid
77
78 trapped_signals="HUP INT QUIT ILL ABRT SEGV FPE ALRM TERM USR1 USR2 BUS"
79
80 die () {
81     printf '[%s] ** error: %s. Aborting.\n' "$(basename $0)" "$*" >&2
82     exit 1
83 }
84
85 smpirun_cleanup()
86 {
87   if [ -z "${KEEP}" ] ; then
88       if [ -z "${PLATFORM}" -a -n "$PLATFORMTMP" ]; then
89         rm -f ${PLATFORMTMP}
90         PLATFORMTMP=""
91       fi
92       if [ ${HOSTFILETMP} = 1 -a -n "$HOSTFILE" ] ; then
93           rm -f ${HOSTFILE}
94           HOSTFILE=""
95       fi
96       if [ ${UNROLLEDHOSTFILETMP} = 1 -a -n "$UNROLLEDHOSTFILE" ] ; then
97           rm -f ${UNROLLEDHOSTFILE}
98           UNROLLEDHOSTFILE=""
99       fi
100       if [ -n ${APPLICATIONTMP} ]; then
101         rm -f ${APPLICATIONTMP}
102         APPLICATIONTMP=""
103       fi
104   fi
105 }
106
107 smpirun_trap() {
108   local sig
109   sig="$1"
110
111   # Cleanup and kill the child process:
112   smpirun_cleanup
113   if ! [ -z "$pid" ]; then
114     kill -TERM $pid
115   fi
116   unset pid
117
118   # Raise the same signal again (remove the traps first):
119   trap - $trapped_signals
120   kill -$sig $$
121
122   # This should never happen:
123   kill -ABRT $$
124   kill -TERM $$
125 }
126
127 for s in $trapped_signals; do
128   trap "smpirun_trap $s" $s
129 done
130
131 while true; do
132     case "$1" in
133         "-np" | "-n")
134             NUMPROCS="$2"
135             shift 2
136             ;;
137         "-bandwidth")
138             NETWORK_BANDWIDTH="$2"
139             shift 2
140             ;;
141         "-latency")
142             NETWORK_LATENCY="$2"
143             shift 2
144             ;;
145         "-platform")
146             PLATFORM="$2"
147             if [ ! -f "${PLATFORM}" ]; then
148                 die "the file '${PLATFORM}' does not exist"
149             fi
150             shift 2
151             ;;
152         "-hostfile" | "-machinefile")
153             HOSTFILE="$2"
154             if [ ! -f "${HOSTFILE}" ]; then
155                 die "the file '${HOSTFILE}' does not exist"
156             fi
157             shift 2
158             ;;
159         "-replay")
160             APP_TRACES="$2"
161             shift 2
162             ;;
163         "-no-privatize")
164             PRIVATIZE="--cfg=smpi/privatization:no"
165             shift 1
166             ;;
167         "-map")
168             MAPOPT=1
169             shift 1
170             ;;
171         "-trace")
172             TRACE_ACTIVE="true"
173             shift 1
174             ;;
175         "-trace-ti")
176             TRACE_ACTIVE="true"
177             TRACE_TI_ACTIVE="true"
178             shift 1
179             ;;
180         "-trace-comment")
181             TRACE_COMMENT="$2"
182             shift 2
183             ;;
184         "-trace-comment-file")
185             TRACE_COMMENT_FILE="$2"
186             shift 2
187             ;;
188         "-trace-file")
189             TRACE_FILENAME="$2"
190             shift 2
191             ;;
192         "-trace-grouped")
193             TRACE_GROUPED="true"
194             shift 1
195             ;;
196         "-trace-resource")
197             TRACE_RESOURCE="true"
198             shift 1
199             ;;
200         "-keep-temps")
201             KEEP="true"
202             SIMOPTS="$SIMOPTS --cfg=smpi/keep-temps:yes"
203             shift 1
204             ;;
205         "-wrapper")
206             WRAPPER="$2"
207             shift 2
208             ;;
209         "-gdb")
210             WRAPPER="gdb --args"
211             KEEP="true"
212             SIMOPTS="$SIMOPTS --cfg=smpi/keep-temps:yes"
213             shift 1
214             ;;
215         "-vgdb")
216             WRAPPER="valgrind --vgdb=yes --vgdb-error=0"
217             KEEP="true"
218             SIMOPTS="$SIMOPTS --cfg=smpi/keep-temps:yes"
219             shift 1
220             ;;
221         "-lldb")
222             WRAPPER="lldb --"
223             KEEP="true"
224             SIMOPTS="$SIMOPTS --cfg=smpi/keep-temps:yes"
225             shift 1
226             ;;
227         "-help" | "--help" | "-h")
228             usage
229             exit 0
230             ;;
231         "-version" | "--version" | "-v")
232             printf '%b\n' "$SIMGRID_VERSION"
233             exit 0
234             ;;
235         "-git-version" | "--git-version")
236             printf '%b\n' "$SIMGRID_GITHASH"
237             exit 0
238             ;;
239         "--cfg="*|"--log="*)
240             for OPT in ${1#*=}
241             do
242                 SIMOPTS="$SIMOPTS ${1%%=*}=$OPT"
243             done
244             shift 1
245             ;;
246         "-foreground")
247             # Nothing to do, compatibility.
248             shift 1
249             ;;
250         *)
251             break
252             ;;
253     esac
254 done
255
256 if [ -n "${APP_TRACES}" ] ; then
257     if [ $# -eq 0 ] ; then
258         EXEC="@SMPIREPLAYMAIN@"
259     else
260         EXEC="$1"
261         shift
262     fi
263 else
264     # check if we still have at least one parameter beyond options
265     if [ $# -eq 0 ]
266     then
267         echo "Error: no program to execute!"
268         usage
269         exit
270     fi
271
272     EXEC="$1"
273     shift
274 fi
275
276 # steel --cfg and --logs options
277 while [ $# -gt 0 ]; do
278     case "$1" in
279         "--cfg="*|"--log="*)
280             for OPT in ${1#*=}
281             do
282                 SIMOPTS="$SIMOPTS ${1%%=*}=$OPT"
283             done
284             shift 1
285             ;;
286         *)
287             PROC_ARGS="${PROC_ARGS:+$PROC_ARGS }$1"
288             shift
289             ;;
290     esac
291 done
292
293 if [ -z "${HOSTFILE}" ] && [ -z "${PLATFORM}" ] ; then
294     echo "No hostfile nor platform specified."
295     usage
296     exit 1
297 fi
298
299 if [ -z "${HOSTFILE}" ] ; then
300     HOSTFILETMP=1
301     HOSTFILE="$(mktemp smpitmp-hostfXXXXXX)"
302     @PYTHON_EXECUTABLE@ -c '
303 import xml.etree.ElementTree as ET
304 import sys
305 import re
306
307 tree = ET.parse(sys.stdin)
308
309 for elem in tree.findall(".//host"):
310     print(elem.attrib["id"])
311
312 for elem in tree.findall(".//cluster"):
313     prefix = elem.attrib["prefix"]
314     radical = elem.attrib["radical"]
315     suffix = elem.attrib["suffix"]
316     for r in radical.split(","):
317         m = re.match("^([^-]*?)-([^-]*)$", r)
318         if m:
319             for i in range(int(m.group(1)), int(m.group(2))):
320                 print(prefix + str(i) + suffix)
321         else:
322             print(prefix + r + suffix)
323             ' < ${PLATFORM} > ${HOSTFILE}
324 fi
325 UNROLLEDHOSTFILETMP=0
326
327 # parse if our lines are terminated by :num_process
328 if grep -q ':' $HOSTFILE ; then
329     UNROLLEDHOSTFILETMP=1
330     UNROLLEDHOSTFILE="$(mktemp smpitmp-hostfXXXXXX)"
331     @PYTHON_EXECUTABLE@ -c '
332 import sys
333 import re
334
335 for line in sys.stdin:
336     m = re.match("(.*):(.*)", line)
337     if m:
338         for i in range(0, int(m.group(2))):
339             print(m.group(1))
340     else:
341         print(line.strip())
342 ' < ${HOSTFILE}  > ${UNROLLEDHOSTFILE}
343     if [ ${HOSTFILETMP} = 1 ] ; then
344         rm ${HOSTFILE}
345         HOSTFILETMP=0
346     fi
347     HOSTFILE=$UNROLLEDHOSTFILE
348 fi
349
350 # Don't use wc -l to compute it to avoid issues with trailing \n at EOF
351 hostfile_procs=$(grep -c "[a-zA-Z0-9]" $HOSTFILE)
352 if [ ${hostfile_procs} = 0 ] ; then
353     die "the hostfile '${HOSTFILE}' is empty"
354 fi
355
356 if [ -z "${NUMPROCS}" ] ; then
357     # Use the amount of processes in the hostfile as default value for the -np parameter
358     NUMPROCS=$hostfile_procs
359 fi
360
361 if [ ${NUMPROCS} -gt ${hostfile_procs} ] ; then
362     echo "You requested to use ${NUMPROCS} ranks, but there is only ${hostfile_procs} processes in your hostfile..." >&2
363 fi
364
365 ##-------------------------------- DEFAULT or SPECIFIED PLATFORM --------------------------------------
366 if [ -z "${PLATFORM}" ]; then
367     PLATFORMTMP="$(mktemp smpitmp-platfXXXXXX)"
368
369     cat > ${PLATFORMTMP} <<PLATFORMHEAD
370 <?xml version='1.0'?>
371 <!DOCTYPE platform SYSTEM "https://simgrid.org/simgrid.dtd">
372 <platform version="4.1">
373 <zone id="AS0" routing="Full">
374 PLATFORMHEAD
375
376     i=${NUMPROCS}
377     while [ $i -gt 0 ]; do
378         echo "  <host id=\"host$i\" speed=\"${SPEED}\"/>" >> ${PLATFORMTMP}
379         echo "  <link id=\"loop$i\" bandwidth=\"${LOOPBACK_BANDWIDTH}\" latency=\"${LOOPBACK_LATENCY}\"/>" >> ${PLATFORMTMP}
380         echo "  <link id=\"link$i\" bandwidth=\"${NETWORK_BANDWIDTH}\" latency=\"${NETWORK_LATENCY}\"/>" >> ${PLATFORMTMP}
381         i=$((i - 1))
382     done
383
384     i=${NUMPROCS}
385     while [ $i -gt 0 ]; do
386         j=${NUMPROCS}
387         while [ $j -gt 0 ]; do
388             if [ $i -eq $j ]; then
389                 echo "  <route src=\"host$i\" dst=\"host$j\"><link_ctn id=\"loop$i\"/></route>" >> ${PLATFORMTMP}
390             else
391                 echo "  <route src=\"host$i\" dst=\"host$j\"><link_ctn id=\"link$i\"/><link_ctn id=\"link$j\"/></route>" >> ${PLATFORMTMP}
392             fi
393             j=$((j - 1))
394         done
395         i=$((i - 1))
396     done
397
398     cat >> ${PLATFORMTMP} <<PLATFORMFOOT
399 </zone>
400 </platform>
401 PLATFORMFOOT
402
403 else
404     PLATFORMTMP=${PLATFORM}
405 fi
406 ##-------------------------------- end DEFAULT or SPECIFIED PLATFORM --------------------------------------
407 ##-------------------------------- DEFAULT APPLICATION --------------------------------------
408 APPLICATIONTMP="$(mktemp smpitmp-appXXXXXX)"
409 #APPLICATIONTMP="app.xml"
410
411 cat > ${APPLICATIONTMP} <<APPLICATIONHEAD
412 <?xml version='1.0'?>
413 <!DOCTYPE platform SYSTEM "https://simgrid.org/simgrid.dtd">
414 <platform version="4.1">
415 APPLICATIONHEAD
416
417 ##---- cache hostnames of hostfile---------------
418 if [ -n "${HOSTFILE}" ] && [ -f ${HOSTFILE} ]; then
419     hostnames=$(cat ${HOSTFILE} | tr '\n\r' '  ')
420 fi
421
422 if [ -n "${APP_TRACES}" ]; then
423     if [ -f "${APP_TRACES}" ]; then
424         hosttraces=$(cat ${APP_TRACES} | tr '\n\r' '  ' )
425         NUMTRACES=$(cat ${APP_TRACES} | wc -l)
426         REPLAY=1
427     else
428         printf "File not found: %s\n" "${APP_TRACES:-\${APP_TRACES\}}" >&2
429         exit 1
430     fi
431 fi
432
433 ##----------------------------------------------------------
434 ##  generate application.xml with hostnames from hostfile:
435 ##  the name of host_i (1<=i<=p, where -np p) is the line i in hostfile (where -hostfile hostfile), or "host$i" if
436 ##  hostfile has less than i lines.
437 ##----------------------------------------------------------
438
439 HAVE_SEQ="$(which seq 2>/dev/null)"
440
441 if [ -n "${HAVE_SEQ}" ]; then
442     SEQ=$(${HAVE_SEQ} 0 $(( NUMPROCS - 1)))
443 else
444     cnt=0
445     while [ $cnt -lt ${NUMPROCS} ] ; do
446         SEQ="$SEQ $cnt"
447         cnt=$((cnt + 1));
448     done
449 fi
450
451 set -- $hostnames
452
453 ##---- generate <actor> tags------------------------------
454 #prepare arguments at once
455 for ARG in $PROC_ARGS; do
456   XML_ARGS="${XML_ARGS}""<argument value=\"${ARG}\"/>
457 "
458 done
459
460 for i in ${SEQ}
461 do
462     j=$(( i % hostfile_procs + 1 ))
463     host=$(eval "echo \${$j}")
464
465     ##---- optional display of ranks to actor mapping
466     if [ ${MAPOPT} = 1 ]; then
467       echo "[rank $i] -> $host"
468     fi
469
470     echo "  <actor host=\"${host}\" function=\"$i\"> <!-- function name used only for logging -->
471     <prop id=\"instance_id\" value=\"smpirun\"/>
472     <prop id=\"rank\" value=\"$i\"/>" >> ${APPLICATIONTMP}
473     if [ ${REPLAY} = 1 ]; then
474         echo "    <prop id=\"smpi_replay\" value=\"true\"/>" >> ${APPLICATIONTMP}
475         if  [ ${NUMTRACES} -gt 1 ]; then
476             echo "    <argument value=\"$(echo $hosttraces|cut -d' ' -f$j)\"/>" >> ${APPLICATIONTMP}
477         else
478             echo "    <argument value=\"$(echo $hosttraces|cut -d' ' -f1)\"/>" >> ${APPLICATIONTMP}
479         fi
480     else
481     echo ${XML_ARGS} >> ${APPLICATIONTMP}
482     fi
483     echo "  </actor>" >> ${APPLICATIONTMP}
484 done
485
486 cat >> ${APPLICATIONTMP} <<APPLICATIONFOOT
487 </platform>
488 APPLICATIONFOOT
489 ##-------------------------------- end DEFAULT APPLICATION --------------------------------------
490 ##---------------------- SMPI TRACING OPTIONS ---------------------------------
491 if [ -n "${TRACE_ACTIVE}" ]; then
492     #define trace filename
493     if [ -n "${TRACE_TI_ACTIVE}" ]; then
494         if [ -z "${TRACE_FILENAME}" ]; then
495             TRACE_FILENAME="smpi_simgrid.txt"
496         fi
497         TRACEOPTIONS="--cfg=tracing:yes --cfg=tracing/filename:${TRACE_FILENAME} --cfg=tracing/smpi:yes --cfg=tracing/smpi/format:TI --cfg=tracing/smpi/computing:yes"
498     else
499         if [ -z "${TRACE_FILENAME}" ]; then
500             TRACE_FILENAME="smpi_simgrid.trace"
501         fi
502         TRACEOPTIONS="--cfg=tracing:yes --cfg=tracing/filename:${TRACE_FILENAME} --cfg=tracing/smpi:yes"
503     fi
504
505     if [ -n "${TRACE_COMMENT}" ]; then
506         TRACEOPTIONS="${TRACEOPTIONS} --cfg=tracing/comment:${TRACE_COMMENT}"
507     fi
508
509     if [ -n "${TRACE_COMMENT_FILE}" ]; then
510         TRACEOPTIONS="${TRACEOPTIONS} --cfg=tracing/comment-file:${TRACE_COMMENT_FILE}"
511     fi
512
513     if [ -n "${TRACE_GROUPED}" ]; then
514         TRACEOPTIONS="${TRACEOPTIONS} --cfg=tracing/smpi/group:yes"
515     fi
516
517     if [ -n "${TRACE_RESOURCE}" ]; then
518         TRACEOPTIONS="${TRACEOPTIONS} --cfg=tracing/categorized:yes --cfg=tracing/uncategorized:yes"
519     fi
520 fi
521 ##---------------------- end SMPI TRACING OPTIONS ---------------------------------
522
523 # Do not remove, this variable may be used by user code (e.g. StarPU)
524 export SMPI_GLOBAL_SIZE=${NUMPROCS}
525 if [ -n "${KEEP}" ] ; then
526     echo ${EXEC} ${PRIVATIZE} ${TRACEOPTIONS} ${SIMOPTS} ${PLATFORMTMP} ${APPLICATIONTMP}
527     if [ ${HOSTFILETMP} = 1 ] ; then
528         echo "Generated hostfile ${HOSTFILE} kept."
529     fi
530     if [ ${UNROLLEDHOSTFILETMP} = 1 ] ; then
531         echo "Generated unrolled hostfile ${UNROLLEDHOSTFILE} kept."
532     fi
533 fi
534
535 # Execute the process
536 #
537 # The shell still need to be alive for the duration in order to do some cleanup after the process.
538 #
539 # We are going through great lengths in order to both keep stdin and be able to handle signals:
540 #
541 # * The job is launched in the background in order to be able to handle signals.
542 #
543 # * The FD 3 is used to temporarily store FD 1. This is because the shell connects FD 1 to /dev/null when the command
544 #   is launched in the background: this can be overriden in bash but not in standard bourne shell.
545 exec 3<&0
546 ${WRAPPER} "@SMPIMAIN@" ${EXEC} ${PRIVATIZE} ${TRACEOPTIONS} ${SIMOPTS} ${PLATFORMTMP} ${APPLICATIONTMP} <&3 3>&- &
547 pid=$!
548 exec 3>&-
549 wait $pid
550 status=$?
551 # With dash on Windows WSL/Ubuntu, "wait" sometimes returns early with an exit
552 # status of 128. Try again.
553 while test $status -eq 128 && kill -0 $pid 2>/dev/null; do
554     wait $pid
555     status=$?
556 done
557 pid=""
558
559 # Keep temporary files on failures to help debugging
560 #
561 if [ ${status} -ne 0 ] ; then
562     if [ -z "${KEEP}" ]; then
563         echo ${EXEC} ${PRIVATIZE} ${TRACEOPTIONS} ${SIMOPTS} ${PLATFORMTMP} ${APPLICATIONTMP}
564         if [ ${HOSTFILETMP} = 1 ] ; then
565             echo "Generated hostfile ${HOSTFILE} kept."
566         fi
567         if [ ${UNROLLEDHOSTFILETMP} = 1 ] ; then
568             echo "Generated unrolled hostfile ${UNROLLEDHOSTFILE} kept."
569         fi
570     fi
571     echo "Execution failed with code ${status}."
572     KEEP=true
573 fi
574
575 smpirun_cleanup
576
577 exit $status